#!/usr/bin/python
import  os, string, sys
from config import *
from repository import class_repository


def get_file_list (list_dirs,include_names,exclude_names):
    "     list_dirs    include_names  exclude_names"

    #     -    enable_rpm - 
    assert list_dirs, "     !"     

    file_list=[]
    for i in list_dirs:
	for ls_string in os.popen("cd %s; ls -s" % i).readlines():
    	    match=ls_regexp.match(ls_string)
	    if match:
		file_list.append([os.path.join(i,match.group(2)),match.group(2),string.atoi(match.group(1)),"part"])
    if include_names:
	"      "
	print "ToDo.  include_rpm_names"	
    
    if exclude_names:
	"      "
	print "ToDo.  exclude_rpm_names"	
    return file_list

def sort_list(list,field):
    "   file_list   field  ()."
    assert list, "  list  sort_list(list,field)" 

    temp=None  #   .
    break_sort=True
    while break_sort:
	break_sort=False
	for i in range(len(list)-1):
	    if list [i] [field] > list [i+1] [field]:
		temp= list[i]
		list[i]=list[i+1]
		list[i+1]=temp
		break_sort=True
    return list

def sort_with_lib_files(list,field):
    """    (libxxx-111-alt.rpm)     (xxx-111-alt.rpm)
    list -    . field -     (  1)."""
    assert list, "  list  sort_with_lib_files(list,field)" 
    for i in list:
	match = lib_regexp.match(i[field])
	if match:
	    i.append(match.group(1))
	else:
	    i.append(i[field])
    tmp_index=len(list[1])-1 #        .
    list = sort_list(list,tmp_index)
    for i in list:   #       .
	del i[tmp_index]
    return list

def simple_split_list_by_size(list,field,prefix):
    "    ,   list[x][field]    list[x][3]  -"
    sum=int(0)
    part=1
    for i in list:
	if sum+i[field] > max_rep_size:
	    sum=i[field]
	    part+=1
	else:
	    sum+=i[field]
	i[3]=(prefix+str(part))
    return list

def create_repositoryes(list):
    rep_list=[]
    rep_list.append(class_repository(list[0][3]))
    rep_cur=rep_list[len(rep_list)-1] # .       ,       
    for list_item in list:
	if list_item[3]!=rep_cur.prefix:
	    rep_create=True
	    for temp in rep_list:
		if list_item[3]==temp.prefix:
		    rep_create=False
		    rep_cur=temp
	    if rep_create:
		rep_list.append(class_repository(list_item[3]))
		rep_cur=rep_list[len(rep_list)-1]
	rep_cur.create_item(list_item[0])
    for i in rep_list:
        i.genbasedirs()

if separate_rpm_and_src_rpm:
    if enable_rpm:
        list=get_file_list(rpm_dirs,include_rpm_names,exclude_rpm_names)
	list=sort_with_lib_files(list,1)
        list=simple_split_list_by_size(list,2,"rpm_disk_")
	create_repositoryes(list)
    if enable_src_rpm:
        list=get_file_list(src_rpm_dirs,include_rpm_names,exclude_rpm_names)
	list=sort_list(list,1)
        list=simple_split_list_by_size(list,2,"srpm_disk_")
	create_repositoryes(list)
	
